/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission 
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE 
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite 
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably 
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
#ifndef INCL_HTTP_TRANSPORT
#define INCL_HTTP_TRANSPORT
/** @cond DEV */

#include "base/fscapi.h"
#include "http/URL.h"
#include "http/Proxy.h"
#include "mapidefs.h"

#define ERROR_INTERNET_OFFLINE_MODE     0x0002                  // Not sure why it's not defined under wininet.h ...
#define MAX_RETRIES                     3                       // Max number of attempts sending http requests.

#include "base/globalsdef.h"

BEGIN_NAMESPACE


/**
 * This class is the transport agent responsible for messages exchange
 * over an HTTP connection.
 * This is a generic abtract class which is not bound to any paltform
 */
class HttpTransport {


public:    
    HttpTransport();
    
    /**
    * The url, and proxy
    * the ISteam where write into the attachment
    */
    HttpTransport(URL& url, Proxy& proxy, IStream* pStream, int extimatedSize = -1);
    
    ~HttpTransport();

    /**
     * It starts the procedure to download the attachment inside the email
     * @return     true if the attachment is downloaded propery, false otherwise
     */
    bool  downloadAttachment();
    
    int realResponseLenght;
    bool exitVar;
    /**
    * it is the extimated size of the attachment. By default it is not set so the download
    * doesn't send any message to any UI
    */
    int extimatedSize;

private:

    URL url;
    Proxy proxy;
    IStream* pStream;
    char* createHttpErrorMessage(DWORD errorCode);    
};


END_NAMESPACE

/** @endcond */
#endif